(function(){
    var localGameVersion = 3;
    var normalGameScriptUrl = 'js/game.js';
    if(Cocoon.Device.getDeviceInfo()) document.addEventListener("deviceready", loadStorageScript, false);
    else loadNormalGameScript();
    function loadStorageScript(){
      var fileURL = window.localGameScriptSrc = cordova.file.dataDirectory + 'game.js';
      var appDirectory = cordova.file.applicationDirectory + 'www/';
      var localScriptURL = appDirectory + normalGameScriptUrl;

      var currentVersion = localStorage.getItem("version");
      if(!currentVersion) {
        localStorage.setItem("version", localGameVersion);
        loadNormalGameScript();
      }
      else{
        window.resolveLocalFileSystemURL(fileURL, function(data1){
          if(currentVersion != localGameVersion){
            localStorage.setItem("version", localGameVersion);
            loadNormalGameScript();
          }
          else loadGameScript(fileURL);
        }, loadNormalGameScript);
      }
    }
    function getVersionHashcode(fileURL, successCallback, failedCallback){
      window.resolveLocalFileSystemURL(fileURL, function (fileEntry) {
        fileEntry.file(function (fileData) {
          var fileReader = new FileReader();
          fileReader.readAsText(fileData);
          fileReader.onload = function (e) {
            var spark = new SparkMD5();
            spark.append(e.target.result);
            successCallback && successCallback(spark.end());
          }
          fileReader.onerror = failedCallback;
        }, failedCallback);
      }, failedCallback);
    }
    function loadNormalGameScript(){
      loadGameScript(normalGameScriptUrl + '?v=' + Date.now());
    }
    function loadGameScript(src){
      var gameScript = loadScript(src);
      gameScript.id = 'gameScript';
    }
    function loadScript(src, onloadCallback){
      if(document && document.head){
        var script = document.createElement('script');
        console.log('loadingScript: ', src);
        script.type = 'text/javascript';
        script.src = src;
        document.head.appendChild(script);
        script.onload = function () {
          onloadCallback && onloadCallback(true);
        }

        script.onerror = function(){
          onloadCallback && onloadCallback(false);
        }
        return script;
      } 
    } 
})();